# -*- coding: utf-8 -*-

# This file is part of Youba (Youpi back end)
# Copyright (C) 2011 AlphaK - http://www.alphak.net/
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import logging, sys, os, settings

if 'win' in sys.platform:
	import ctypes
else:
	import portio

log = logging.getLogger('parallel')
log.addHandler(logging.StreamHandler())

class ParallelInterface:

	def __init__(self):

		self.ISWIN = False
		if 'win' in sys.platform:
			self.ISWIN = True
			self.p = ctypes.windll.inpout32
		
		else:
			self.ISWIN = False
			if os.getuid():
				raise Exception('You need to be root, exiting.')
			status = portio.ioperm(settings.PARALLEL_PORT, 1, True)
			if status:
				raise Exception('IOperm: %s' % os.strerror(status))
		

	def write(self, byte):
		if(self.ISWIN):
			self.p.Out32(settings.PARALLEL_PORT, byte)
		else:
			portio.outb(byte, settings.PARALLEL_PORT)
